#pragma once

#include <string>

#include "AddressInfo.h"

class CBkBsfilProfileManager;

////////////////////////////////////////////////////////////////////////
// ݒ̃x[XNX
////////////////////////////////////////////////////////////////////////

class BkBsfilProfileBase {
public:
	// RXgN^
	BkBsfilProfileBase();
	// fXgN^
	virtual ~BkBsfilProfileBase();

public:
	// rp̃IuWFNgݒ肷
	void SetLockObject(CRITICAL_SECTION* pcsProfile);

public:
	// 
	virtual void Initialize() = 0;
	// ݒǂݏ
	virtual void ProfileRW(CBkBsfilProfileManager& profManager, BOOL isWrite) = 0;

protected:
	// rp
	CRITICAL_SECTION* m_pcsProfile;
};

////////////////////////////////////////////////////////////////////////
// BkBsfilWrapper ̐ݒ
////////////////////////////////////////////////////////////////////////

class BkBsfilProfile : public BkBsfilProfileBase
{
public:
	// wb_̃wb_tB[hɓ͂łő啶
	static const int NUM_CHAR_SPAM_HEADER_FIELD_NAME_MAX = 30;
	// wb_̃wb_tB[h{fBɓ͂łő啶
	static const int NUM_CHAR_SPAM_HEADER_FIELD_BODY_MAX = 30;

public:
	// spam Ɣ肳ꂽ[̏u
	enum ProcessSpamMail {
		GoTrash,
		NoMove,
		GoFolder,
		AddHeader,
	};

public:
	// RXgN^
	BkBsfilProfile();

public:
	// 
	void Initialize();
	// ݒǂݏ
	void ProfileRW(CBkBsfilProfileManager& profManager, BOOL isWrite);

public:
	// spam Ɣ肳ꂽ[̏u
	ProcessSpamMail GetProcSpam();
	void SetProcSpam(ProcessSpamMail procSpam);

	// uwtH_ցv̏ꍇ̃tH_
	std::string GetSpamFolder();
	void SetSpamFolder(std::string spamFolder);

	// uwb_tv̏ꍇ̃wb_
	std::string GetSpamHeaderFieldName();
	void SetSpamHeaderFieldName(std::string spamHeaderFieldName);
	std::string GetSpamHeaderFieldBody();
	void SetSpamHeaderFieldBody(std::string spamHeaderFieldBody);

	// tH_ֈړꍇɊe[{bNX̓ʒũtH_Ɉړ
	bool GetGoFolderSameRelativeFolderPath();
	void SetGoFolderSameRelativeFolderPath(bool goFolderSameRelativeFolderPath);

	// spam Ɣ肳ꂽ[͊ǂɂ
	bool GetSetReadToSpamMail();
	void SetSetReadToSpamMail(bool setReadToSpamMail);

	// OɃbZ[W{bNX\Ȃ
	bool GetDisableBeforeMsgbox();
	void SetDisableBeforeMsgbox(bool disableBeforeMsgbox);

	// ʕ\̃bZ[W{bNX\Ȃ
	bool GetDisableResultMsgbox();
	void SetDisableResultMsgbox(bool disableResultMsgbox);

	// N bsfilter f[^x[XQƂȂ
	bool GetDontCheckDbOnStart();
	void SetDontCheckDbOnStart(bool dontCheckDbOnStart);

	// MɑMzCgXgɒǉ
	bool GetAddToAddrToWhiteListOnSend();
	void SetAddToAddrToWhiteListOnSend(bool addToAddrToWhiteListOnSend);

	// 莞у[wK clean ȃ[ spam wb_Ȃ
	bool GetDontRemoveSpamHeader();
	void SetDontRemoveSpamHeader(bool dontRemoveSpamHeader);

	// Ox
	std::string GetLogLevel();
	void SetLogLevel(std::string logLevel);

private:
	// spam Ɣ肳ꂽ[̏u
	ProcessSpamMail m_procSpam;
	// uwtH_ցv̏ꍇ̃tH_
	std::string m_spamFolder;
	// uwb_tv̏ꍇ̃wb_
	std::string m_spamHeaderFieldName;	// wb_tB[h
	std::string m_spamHeaderFieldBody;	// wb_tB[h{fB
	// tH_ֈړꍇɊe[{bNX̓ʒũtH_Ɉړ
	bool m_goFolderSameRelativeFolderPath;
	// spam Ɣ肳ꂽ[͊ǂɂ
	bool m_setReadToSpamMail;
	// N bsfilter f[^x[XQƂȂ
	bool m_dontCheckDbOnStart;
	// OɃbZ[W{bNX\Ȃ
	bool m_disableBeforeMsgbox;
	// ʕ\̃bZ[W{bNX\Ȃ
	bool m_disableResultMsgbox;
	// MɑMzCgXgɒǉ
	bool m_addToAddrToWhiteListOnSend;
	// 莞у[wK clean ȃ[ spam wb_Ȃ
	bool m_dontRemoveSpamHeader;
	// Ox
	std::string m_logLevel;
};

////////////////////////////////////////////////////////////////////////
// BkBsfilWrapper ̐ݒ(p)
////////////////////////////////////////////////////////////////////////

class BkBsfilProfileEnv : public BkBsfilProfileBase
{
public:
	// RXgN^
	BkBsfilProfileEnv();

public:
	// 
	void Initialize();
	// ݒǂݏ
	void ProfileRW(CBkBsfilProfileManager& profManager, BOOL isWrite);

//
// zCgXg UI ̐ݒ
//
public:
	// \[g
	WhiteList::SortKey GetSortKey();
	void SetSortKey(WhiteList::SortKey sortKey);

	// \[g
	bool IsAscending();
	void SetAscending(bool bAscending);

	// ڕ(AhX̎)
	int GetAddrTypeItemWidth();
	void SetAddrTypeItemWidth(int width);

	// ڕ([AhX)
	int GetEmailAddrItemWidth();
	void SetEmailAddrItemWidth(int width);

	// ڕ(l)
	int GetNoteItemWidth();
	void SetNoteItemWidth(int width);

private:
	// \[g
	std::string m_sortItemName;
	// \[g
	bool m_bAscending;
	// ڕ(AhX̎)
	int m_addrTypeItemWidth;
	// ڕ([AhX)
	int m_emailAddrItemWidth;
	// ڕ(l)
	int m_noteItemWidth;
};

////////////////////////////////////////////////////////////////////////
// ݒ̓ǂݏs
////////////////////////////////////////////////////////////////////////

class CBkBsfilProfileManager
{
public:
	// RXgN^
	CBkBsfilProfileManager();
	// fXgN^
	~CBkBsfilProfileManager();

public:
	// ݒ[h
	void Load(BkBsfilProfileBase& bkBsfilProf, std::string filepath);
	// ݒZ[u
	void Save(BkBsfilProfileBase& bkBsfilProf, std::string filepath = "");

public:
	// X̒lǂݏ
	template <class T>
	void ItemRW(std::string& section, std::string& key, T& value);
	// lǂ
	void ReadItem(std::string& section, std::string& key, std::string& value, std::string defaultValue);
	void ReadItem(std::string& section, std::string& key, int& value, int defaultValue);
	// l
	void WriteItem(std::string& section, std::string& key, std::string value);
	void WriteItem(std::string& section, std::string& key, int value);

private:
	// ݒt@C̃pX
	std::string m_filepath;
	// ǂݏtO
	bool m_isWrite;
};
