#include "stdafx.h"

#include <windowsx.h>
#include <commctrl.h>
#include <shtypes.h>
#include <shlobj.h>

#include "resource.h"
#include "Util.h"
#include "BrowseBeckyFolderDlg2.h"

////////////////////////////////////////////////////////////////////////
// tH_IEBhE
////////////////////////////////////////////////////////////////////////

// g̃CX^X
CBrowseBeckyFolderDlg2* CBrowseBeckyFolderDlg2::s_pThis;

//----------------------------------------------------------------------
// RXgN^
//----------------------------------------------------------------------

CBrowseBeckyFolderDlg2::CBrowseBeckyFolderDlg2(CBeckyAPI* pbka) :
	m_pTitle(""),
	m_pbka(pbka)
{
	// NOTE: !!!!!!!!!!
	//       CBrowseBeckyFolderDlg2 ̃CX^Xx 2 ȏg
	//       낵ƂɂȂB
	s_pThis = this;

	// tH_̃C[W[h
	m_hImgList = ImageList_Create(16, 16, ILC_COLOR24 | ILC_MASK, 1, 1);
	HICON hImage = CResourceManager::LoadIconImage(MAKEINTRESOURCE(IDI_ICON_BECKY_FOLDER), 16, 16, LR_DEFAULTCOLOR);
	ImageList_AddIcon(m_hImgList, hImage);
}

//----------------------------------------------------------------------
// fXgN^
//----------------------------------------------------------------------

CBrowseBeckyFolderDlg2::~CBrowseBeckyFolderDlg2()
{
	if (m_hImgList) {
		ImageList_Destroy(m_hImgList);
	}
}

//----------------------------------------------------------------------
// \
//----------------------------------------------------------------------

int CBrowseBeckyFolderDlg2::DoModal(HWND hWndParent, const char* bkaDataFolder, const char* selFolder, const char* pTitle)
{
	m_bkaDataFolder = bkaDataFolder;
	if (Util::EndsWithPathDelimiter(m_bkaDataFolder)) {
		m_bkaDataFolder = m_bkaDataFolder.substr(0, m_bkaDataFolder.length() - 1);
	}
	m_selFolder = selFolder;
	if (Util::EndsWithPathDelimiter(m_selFolder)) {
		m_selFolder = m_selFolder.substr(0, m_selFolder.length() - 1);
	}
	m_pTitle = pTitle;

	return CResourceManager::DlgBox(MAKEINTRESOURCE(IDD_BROWSE_BECKY_FOLDER), hWndParent, DialogProcStatic);
}

//----------------------------------------------------------------------
// IꂽpX擾
//----------------------------------------------------------------------

std::string CBrowseBeckyFolderDlg2::GetFolderPath()
{
	return m_folderPath;
}

//----------------------------------------------------------------------
// _CAOvV[W(]p)
//----------------------------------------------------------------------

BOOL CALLBACK CBrowseBeckyFolderDlg2::DialogProcStatic(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	return s_pThis->DialogProc(hWnd, uMsg, wParam, lParam);
}

//----------------------------------------------------------------------
// _CAOvV[W
//----------------------------------------------------------------------

BOOL CBrowseBeckyFolderDlg2::DialogProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg) {
	HANDLE_MSG(hWnd, WM_INITDIALOG, OnInitDialog);
	HANDLE_MSG(hWnd, WM_COMMAND, OnCommand);
	HANDLE_MSG(hWnd, WM_NOTIFY, OnNotify);
	}

	return FALSE;
}

//----------------------------------------------------------------------
// WM_INITDIALOG nh
//----------------------------------------------------------------------

BOOL CBrowseBeckyFolderDlg2::OnInitDialog(HWND hWnd, HWND hWndFocus, LPARAM lParam)
{
	//
	// _CAO𒆉ɕ\
	//

	HWND hWndParent = GetParent(hWnd);

	Util::CenterWindow(hWndParent, hWnd);

	//
	// s
	//

	// ^Cgݒ肷
	SetWindowText(GetDlgItem(hWnd, IDC_DESCRIPTION), m_pTitle);

	//
	// tH_ݒ肷
	//
	HWND hTreeView = GetDlgItem(hWnd, IDC_FOLDER_TREE);

	// c[r[ɃGNXv[[X^CKp
	ApplyTreeViewExplorerStyle(hTreeView);

	// C[WXgݒ肷
	TreeView_SetImageList(hTreeView, m_hImgList, TVSIL_NORMAL);

	// Becky! ̃tH_ꗗ쐬
	AddTreeViewBeckyFoler(m_bkaDataFolder.c_str(), hTreeView, TVI_ROOT, 2);	// ɑSǂݍ܂Ȃ(2 Kw܂)

	return TRUE;
}

//----------------------------------------------------------------------
// WM_COMMAND nh
//----------------------------------------------------------------------

void CBrowseBeckyFolderDlg2::OnCommand(HWND hWnd, int idCtl, HWND hWndCtl, UINT codeNotify)
{
	switch (idCtl) {
	case IDOK:
		{
			// IꂽtH_̃pX𓾂
			HWND hTreeView = GetDlgItem(hWnd, IDC_FOLDER_TREE);
			HTREEITEM hItem = TreeView_GetSelection(hTreeView);
			if (hItem) {
				for (std::map<std::string, HTREEITEM>::iterator it = m_folderList.begin(); it != m_folderList.end(); ++it) {
					if (it->second == hItem) {
						m_folderPath = it->first;
						break;
					}
				}
			}

			EndDialog(hWnd, idCtl);
		}
		break;

	case IDCANCEL:
		EndDialog(hWnd, idCtl);
		break;
	}
}

//----------------------------------------------------------------------
// WM_NOTIFY nh
//----------------------------------------------------------------------

BOOL CBrowseBeckyFolderDlg2::OnNotify(HWND hWnd, int idCtrl, NMHDR* pnmhdr)
{
	std::string folderPath;
	switch (pnmhdr->idFrom) {
	case IDC_FOLDER_TREE:
		switch (pnmhdr->code) {
		case TVN_ITEMEXPANDED:
			{
				NMTREEVIEW* pnmtview = (NMTREEVIEW*) pnmhdr;
				HTREEITEM hItem = pnmtview->itemNew.hItem;
				if (hItem && (pnmtview->action & TVE_EXPAND)) {
					HWND hTreeView = GetDlgItem(hWnd, IDC_FOLDER_TREE);
					for (std::map<std::string, HTREEITEM>::iterator it = m_folderList.begin(); it != m_folderList.end(); ++it) {
						if (it->second == hItem) {
							AddTreeViewBeckyFoler(it->first.c_str(), hTreeView, hItem, 2);	// S͓ǂݍ܂Ȃ(2 Kw܂)
							break;
						}
					}
				}
			}
			break;
		}
	}

	return FALSE;
}

//----------------------------------------------------------------------
// c[r[ɃGNXv[[X^CKp
//----------------------------------------------------------------------

typedef HRESULT (WINAPI* PF_SetWindowTheme)(HWND hwnd, LPCWSTR pszSubAppName, LPCWSTR pszSubIdList);

void CBrowseBeckyFolderDlg2::ApplyTreeViewExplorerStyle(HWND hWnd)
{
	bool applyExplorerStyle = false;

	OSVERSIONINFO osVer;
	ZeroMemory(&osVer, sizeof(osVer));
	osVer.dwOSVersionInfoSize = sizeof(osVer);

	BOOL rc = GetVersionEx(&osVer);
	if (rc) {
		if (6 <= osVer.dwMajorVersion) {
			// Vista ȍ~
			applyExplorerStyle = true;
		} else if (5 <= osVer.dwMajorVersion && 1 <= osVer.dwMinorVersion) {
			// XP, Server 2003
			applyExplorerStyle = true;
		}
	}

	if (!applyExplorerStyle) {
		return;
	}

	HMODULE hModTheme = LoadLibrary("uxtheme.dll");
	if (!hModTheme) {
		return;
	}

	do {
		PF_SetWindowTheme setWindowTheme = (PF_SetWindowTheme) GetProcAddress(hModTheme, "SetWindowTheme");
		if (!setWindowTheme) {
			break;
		}

		setWindowTheme(hWnd, L"explorer", 0);

	} while (false);

	FreeLibrary(hModTheme);
}

//----------------------------------------------------------------------
// c[r[ɃtH_ǉ
//----------------------------------------------------------------------

void CBrowseBeckyFolderDlg2::AddTreeViewBeckyFoler(const char* parentFolder, HWND hTreeView, HTREEITEM hParent, int findLevel)
{
#define __FUNCNAME__ "CBrowseBeckyFolderDlg2::AddTreeViewBeckyFoler()"
	char* pcfnname = "";

	int parentFolderLength = strlen(parentFolder);

	if (_strnicmp(parentFolder, m_selFolder.c_str(), parentFolderLength) == 0) {
		// ̑IĂtH_ɐ擪vꍇ͌xɊ֌WȂA𑱂
	} else if (findLevel <= 0) {
		return;
	}

	// tH_̃tH_ꗗ𓾂
	std::vector<std::string> folderNameList;
	GetFolderList(parentFolder, &folderNameList);

	int bkDtFolderlength = m_bkaDataFolder.length();

	for (std::vector<std::string>::iterator it = folderNameList.begin(); it != folderNameList.end(); ++it) {
		std::string folderName = *it;

		char bkFolderpath[MAX_PATH * 4];

		_snprintf(bkFolderpath, sizeof(bkFolderpath), "%s\\%s", parentFolder, folderName.c_str());
		FORCE_ASCIZ(bkFolderpath);

		HTREEITEM hItem = 0;

		if (m_folderList.count(bkFolderpath) == 0) {

			// ܂AǉĂȂꍇ̂݁Aǉ

			// \擾
			std::string bkFolder;
			bkFolder = &bkFolderpath[bkDtFolderlength + 1];
			bkFolder += "\\";

			// NOTE: \擾̂߂ɂׂẴtH_ɑ΂ GetFolderDisplayName() ĂяoA
			//       ̂擾ł̂̂݁Aǉ悤ɂĂAGetFolderDisplayName() Ăяo̓RXg悤ŁA
			//       ɎԂ邽߁A\xグ邽߂ɁA
			//       E擪 '!' Ŏn܂邩AΏۂ[g̏ꍇ́A\𓾂
			//       E擪 '#' ܂ "." Ŏn܂̂́AǉȂ
			//       EȊO̓tH_̂܂܎g
			//       ƂAŖ{ɐ̂͂킩ȂBBB
			std::string displayName;

			if (folderName.c_str()[0] == '!' || hParent == TVI_ROOT) {
				// \𓾂
				const char* pDisplayName = m_pbka->GetFolderDisplayName(bkFolder.c_str());
				if (pDisplayName && strlen(pDisplayName) != 0) {
					// \A[g̎ [[AhX]AȊO̓tH_݂̂ƂB
					displayName = pDisplayName;
					if (hParent != TVI_ROOT) {
						int pos;

						// "[[AhX] tH_/TutH_"  " tH_/TutH_" o
						if ((pos = displayName.find("]")) == std::string::npos) {
							displayName = Util::Trim(displayName);
						} else {
							displayName = displayName.substr(pos + 1);
						}

						// "tH_/TutH_"  "TutH_" o
						if ((pos = displayName.rfind("/")) != std::string::npos) {
							displayName = displayName.substr(pos + 1);
						}
					}
					displayName = Util::Trim(displayName);
				}

			} else if (folderName.c_str()[0] == '#' || folderName.c_str()[0] == '.') {
				// ǉȂ
			} else {
				// ̂܂܂̃tH_g
				displayName = folderName;
			}
					
			if (displayName.length() != 0) {

				TV_INSERTSTRUCT tv;
				ZeroMemory(&tv, sizeof(tv));
				tv.hParent = hParent;
				tv.hInsertAfter = TVI_LAST;
				tv.item.mask = TVIF_TEXT | TVIF_IMAGE | TVIF_PARAM;
				tv.item.pszText = (char*) displayName.c_str();
				tv.item.iImage = 0;

				hItem = TreeView_InsertItem(hTreeView, &tv);
				m_folderList[bkFolderpath] = hItem;

				if (_stricmp(m_selFolder.c_str(), bkFolderpath) == 0) {
					// ̑IĂtH_ł΁AI
					TreeView_Select(hTreeView, hItem, TVGN_CARET);
				}
			} else {
				// ܂Ă܂Ȃ悤ɁAoĂ(c[ɂ͕\Ȃ)
				m_folderList[bkFolderpath] = 0;
			}

		} else {
			// ǉς݂̏ꍇ͍ڂ̃nh𓾂
			hItem = m_folderList[bkFolderpath];

			//  1 Kwς݂𒲂ׂ΁A1 KwȂėǂȂ̂A
			// ₱Ȃ肻Ȃ̂łĂȂB
		}

		if (hItem) {
			AddTreeViewBeckyFoler(bkFolderpath, hTreeView, hItem, findLevel - 1);
		}
	}

#undef __FUNCNAME__
}

//----------------------------------------------------------------------
// w̃tH_z̃tH_ꗗ𓾂
//----------------------------------------------------------------------

void CBrowseBeckyFolderDlg2::GetFolderList(const char* parentFolder, std::vector<std::string>* pFolderNameList)
{
	WIN32_FIND_DATA findData;
	char searchPath[MAX_PATH * 4];

	_snprintf(searchPath, sizeof(searchPath), "%s\\*.*", parentFolder);
	FORCE_ASCIZ(searchPath);

	HANDLE hFind = INVALID_HANDLE_VALUE;

	do {

		hFind = FindFirstFile(searchPath, &findData);
		if (hFind == INVALID_HANDLE_VALUE) {
			break;
		}

		for (;;) {

			if (strcmp(findData.cFileName, ".") != 0 && strcmp(findData.cFileName, "..") != 0 && findData.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY) {
				pFolderNameList->push_back(findData.cFileName);
			}

			BOOL rc = FindNextFile(hFind, &findData);
			if (!rc) {
				break;
			}
		}

	} while (false);

	if (hFind != INVALID_HANDLE_VALUE) {
		FindClose(hFind);
	}

	// NOTE:  IShellFolder gĂ݂A܂葬x͕ςȂB
	//       tH_擾̒xʂɃ{glbN悤Ȃ̂ŁA
	//       FindXXX() n֐łɖ߂Ȃ΍{ƂɂB
#if 0
	CoInitializeEx(0, COINIT_APARTMENTTHREADED);

	HRESULT hr;
	LPSHELLFOLDER pShellFolder = 0;
	LPITEMIDLIST parentPidl = 0;
	LPSHELLFOLDER pShellFolderParent = 0;

	do {

		hr = SHGetDesktopFolder(&pShellFolder);
		if (!SUCCEEDED(hr)) {
			break;
		}

		wchar_t wParentFolder[MAX_PATH * 4];
		int chCount = MultiByteToWideChar(CP_ACP, 0, parentFolder, -1, wParentFolder, sizeof(wParentFolder)/sizeof(wchar_t));
		if (chCount == 0) {
			break;
		}

		hr = pShellFolder->ParseDisplayName(0, 0, wParentFolder, 0, &parentPidl, 0);
		if (!SUCCEEDED(hr)) {
			break;
		}

		hr = pShellFolder->BindToObject(parentPidl, 0, IID_IShellFolder, (void**) &pShellFolderParent);
		if (!SUCCEEDED(hr)) {
			break;
		}

		LPENUMIDLIST enumIDList = 0;
		hr = pShellFolderParent->EnumObjects(0, SHCONTF_FOLDERS, &enumIDList);
		if (!SUCCEEDED(hr)) {
			break;
		}

		STRRET subFolderName;
		LPITEMIDLIST subFolderPidl = 0;
		while (enumIDList->Next(1, &subFolderPidl, 0) == NOERROR) {

			pShellFolderParent->GetDisplayNameOf(subFolderPidl, SHGDN_NORMAL, &subFolderName);

			std::string csSubFolerName;
			switch (subFolderName.uType) {
			case STRRET_CSTR:
				csSubFolerName = subFolderName.cStr;
				break;
			case STRRET_OFFSET:
				csSubFolerName = (char*) (((BYTE*) subFolderPidl) + subFolderName.uOffset);
				break;
			case STRRET_WSTR:
				{
					char buffer[MAX_PATH * 4];
					int cvCount = WideCharToMultiByte(CP_ACP, 0, subFolderName.pOleStr, -1, buffer, sizeof(buffer), 0, 0);
					if (0 < cvCount) {
						csSubFolerName = buffer;
					}
				}
				break;
			}

			if (subFolderName.uType == STRRET_WSTR) {
				CoTaskMemFree(subFolderName.pOleStr);
			}

			CoTaskMemFree(subFolderPidl);

			if (0 < csSubFolerName.length()) {
				pFolderNameList->push_back(csSubFolerName);
			}
		}
		if (enumIDList) {
			enumIDList->Release();
		}

	} while (false);

	if (pShellFolderParent) {
		pShellFolderParent->Release();
	}
	if (parentPidl) {
		CoTaskMemFree(parentPidl);
	}
	if (pShellFolder) {
		pShellFolder->Release();
	}

	CoUninitialize();
#endif
}
